/* Copyright 2009, Chris Glasier

CONTENTS

VARIABLES
START
LISTS AND ARRAYS
CHILDREN RUN OFF
EVENTS IN SLIDERS
EVENTS IN MENUS
UPDATER
SCENES ADDED OR REMOVED BY USER
SET UP FUNCTIONS (LAYOUT)
RESIZING
*/


panelWidth = 	230        	//suggested
panelHeight = 	345       	//suggested
cellHeight = 	 20         //reccommended standard
columns     = 	  3         // for this device functionality
stripeTop = 	  5         //rows from top of devicePanel
sliderTops = 	new Array(0,0,0)	//slider position record

/////FIXED LISTS; SCENES, LAYERS, COMPONENTS AND STYLES FROM MODEL DATA
// genericName,givenName,visibility(font colour)

aspectArray = new Array()
aspectArray.push(new Array("Properties","Property","true"))
aspectArray.push(new Array("Layers","Layer","true"))
aspectArray.push(new Array("Components","Component","true"))
aspectArray.push(new Array("Styles","Style","true"))
aspectArray.push(new Array("Views","View","true"))

viewsArray = new Array()
viewsArray.push(new Array("View","Top","true"))
viewsArray.push(new Array("View","Bottom","true"))
viewsArray.push(new Array("View","Front","true"))
viewsArray.push(new Array("View","Back","true"))
viewsArray.push(new Array("View","Left","true"))
viewsArray.push(new Array("View","Right","true"))
viewsArray.push(new Array("View","Isometric","true"))
viewsArray.push(new Array("View","ZoomExtents","true"))
viewsArray.push(new Array("View","Perspective","true"))



//TEMPORARY NAMESET INTEGRATION SOLUTION - TOP LEVEL MENUS NOT USED


function menu1Down(e){}
function menu2Down(e){}




/////FUNCTION CALL FROM HTML FILE

/*
sets the size, sets variables, makes confirmPanel into start button for Mac compatibility (http://forums.sketchucation.com/viewtopic.php?f=180&t=19932#p166378)
*/


//This method of starting needs to be changed!

function start(){;
    sceneDialogSize();
	sceneSet() 
	    with(confirmPanel) {
        innerHTML = "START";
        with(style){
            left = cellWidth*2;
            top =   cellHeight;
            width = cellWidth;
			display = "block"
			}
		}
	}	




//SET DIALOG SIZE TO DEFAULT (left & top position as last session)

function sceneDialogSize() {
    w = panelWidth+6
    h = panelHeight+30
    cellWidth = Math.floor(panelWidth/columns)
    rows = Math.floor(panelHeight/cellHeight)
    params = new Array(w,h)
    params = params.join(",")
    window.location = "skp:coreSet_size@"+ params 
	}
	


//CONFIRM BUTTON - for start,update and confirm input
	
function confirmDown(e){
	switch(confirmPanel.innerHTML){
		case "START": 
		sceneStart()
		break;
		case "UPDATE": 
		confirmPanel.style.display = "none"
		window.location = "skp:sceneUpdate" 
		break
		case "CONFIRM" : 
		coll = document.getElementById("sc2").childNodes
		if(coll[0].firstChild.tagName == "INPUT"){
			//Capitalises first letter for sorting
			newName = document.getElementById("transferBox").value
			newName = newName.charAt(0).toUpperCase()+newName.substr(1).toLowerCase()
			params = new Array(newName)
			params = params.join(",")
			confirmPanel.innerHTML =  "UPDATE"
			confirmPanel.style.backgroundColor = "#ff0000"
			window.location = "skp:sceneLayersRename@"+params
			layersArray.sort()
			childNos = layersArray
			sliderTops[2] = 0
			colNo = 2
			sceneChildrenRun()  
			} 
		break
		}  
	}
 
  
  
  
function sceneStart(){
	//DETERMINES EXISTING OR DEFAULT SCENES LIST
    window.location = "skp:sceneStart" 
    }  
   
   

//RETURN FROM skp:sceneStart; sets layout, generates local panels, opens scenes and aspects

 
function sceneStartRun(recd){
	sceneSet()   //see SETUP SECTION below
	sceneList = recd
	sceneSceneList()
	sceneAspectList()	
	}
	
	
/////SCENES	
	

function sceneSceneList(){
	sceneList = sceneList.split(",")
	ind = sceneList[0]
	list = sceneList.slice(1)
	sceneArray = new Array()
	for(a=0; a<list.length; a++){
		//for correct sorting and consistency
		thisName = list[a].charAt(0).toUpperCase()+list[a].substr(1).toLowerCase()
		thisName = thisName.split(" ");
		thisName = thisName.join("_")	
		entry = new Array()
		entry[0] = "Scene"
		entry[1] = thisName
		entry[2] = "true"
		sceneArray.push(entry)  
		} 
	childNos = sceneArray
	colNo = 0
	sceneChildrenRun()
	colNo = 0
	activeRow = ind
	sliderTops[0] = activeRow
	params = new Array(colNo,activeRow)
	params = params.join(",")
	sceneSliderAdjust(params)
	}


	
	
/////ASPECTS



function sceneAspectList(){
	sliderTops[1] = 0
	childNos = aspectArray
	colNo = 1
	sceneChildrenRun()  
	}


	
	
/////PROPERTIES



function scenePropertiesList(){
	window.location = "skp:scenePropertiesList" 
	}




function scenePropertiesListRun(theArray){
	list = theArray.split(";")
	propertiesArray = new Array()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		entry = new Array()
		entry[0] = "Property"
		entry[1] = thisName
		entry[2] = couplet[1]
		propertiesArray.push(entry)  } 
	scenePropertiesListChildren()  
	}

	
function scenePropertiesListChildren(){
	childNos = propertiesArray
	colNo = 2
	sceneChildrenRun() 
	}




/////LAYERS



function sceneLayersList(){
	window.location = "skp:sceneLayersList"   
	}


function sceneLayersListRun(theArray){
	list = theArray.split(";")
	list.sort()
	//VISIBILITY SPLITTER
	if(layerSort == "vis"){
		visArray = new Array()
		invArray = new Array()
		for(a=0; a<list.length; a++){
			list[a]=list[a].split(",")
			if(list[a][1] == "true") visArray.push(list[a].join(","))
			else invArray.push(list[a].join(","))
			}
		list = visArray.concat(invArray)   
		}
	layersArray = new Array()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		//Layer0 not editable in cgScenes
		if(thisName == "Layer0") continue
		entry = new Array()
		entry[0] = "Layer"
		entry[1] = thisName
		entry[2] = couplet[1]
		entry[3] = couplet[2]
		layersArray.push(entry)  
		} 
	sceneLayersListChildren()
	}


function sceneLayersListChildren(){
	childNos = layersArray
	colNo = 2
	sceneChildrenRun()  
	}



/////COMPONENTS



function sceneComponentsList(){
	window.location = "skp:sceneComponentsList"   
	}



function sceneComponentsListRun(theArray){
	list = theArray.split(";")
	componentsArray = new Array()
	for(a=0; a<list.length; a++){
		list[a] = list[a].charAt(0).toUpperCase()+list[a].substr(1).toLowerCase()  
		}
	list.sort()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		if(componentSort == "show") couplet[1] = "false" //all show
		if(componentSort == "hide") couplet[1] = "true"  // all hide
		//otherwise uses SU data
		entry = new Array()
		entry[0] = "Component"
		entry[1] = thisName
		couplet[1]=="false"? entry[2] = "true" : entry[2] = "false"
		entry[3] = couplet[2]
		componentsArray.push(entry)  
		} 
		sceneComponentsListChildren()
	}



function sceneComponentsListChildren(){
	childNos = componentsArray
	if(childNos.length-1 < stripeTop)sliderTops[2] = childNos.length-1
	else sliderTops[2] = stripeTop
	colNo = 2
	sceneChildrenRun()   
	}




/////STYLES



function sceneStylesList(){
	window.location = "skp:sceneStylesList"  
	}





function sceneStylesListRun(theArray){
	stylesArray = new Array()
	theArray = theArray.split("qq")
	list = theArray[0].split(";")
	activeStyle = theArray[1]
	list.sort()
	for(a=0; a<list.length; a++){
		couplet = list[a].split(",")
		if(couplet[0] == activeStyle) activeRow = a
		sliderTops[2] = activeRow
		thisName = couplet[0].split(" ")
		thisName = thisName.join("_")
		entry = new Array()
		entry[0] = "Style"
		entry[1] = thisName
		entry[2] ="true"
		entry[3] = couplet[1]
		stylesArray.push(entry)  
		} 
	sceneStylesListChildren()
	}




function sceneStylesListChildren(){
	childNos = stylesArray
	colNo = 2
	sceneChildrenRun()
	colNo = 1  
	}



function sceneViewsList(){
	childNos = viewsArray
	colNo = 2 
	sceneChildrenRun()
	}




//CHILDREN RUN OFF


function sceneChildrenRun(){
	with(document.getElementById("sc"+ colNo)){
		innerHTML = ""	
		with(style){
			cTop = sliderTops[colNo] - stripeTop
			top = -cTop*cellHeight
			}
		}
	bTop = 0
	for(c=0; c<childNos.length; c++){
		genericName = childNos[c][0]
		givenName = childNos[c][1]
		childNos[c][2] == "false"? theClass = "off" : theClass = "on"
		childNos[c][3] == undefined? entsInd = 0 : entsInd = childNos[c][3]
		obj = document.createElement("div")
		document.getElementById("sc"+ colNo).appendChild(obj)
		with(obj){
			id = new Array(genericName,colNo,c,entsInd)
			innerHTML = givenName
			title = id            //for testing
			className = theClass 
			with(style){
				left = 0
				top = bTop 
				width = "95%"
				height = cellHeight   
				}   
			}
		bTop+= cellHeight    
		} 
	}


	

//EVENTS IN SLIDERS



var counter = 0
var lastCellId = "undefined"

function coreTarget(e){
	var targ;
	if (!e) {
		var e = window.event 
		}
	if (e.target){
		targ = e.target;  
		}
	else if (e.srcElement){
		targ = e.srcElement;  
		}
	thisCell = targ  
	}


	
	
//DEVICE DOWN IS STANDARD (there should be no mouse events in device code)



function deviceDown(e){
	coreTarget()
	if(thisCell.id == "holder" ) return
	if(thisCell.id == "dmenu" ) return
	if(thisCell.tagName == "INPUT") return
	//DEVICE MENUS
	if(thisCell.parentNode.id == "dmenu"){
		try{
			deviceMenuDown() 
			}
		catch(e){
			}
		return 
		}
	//ONE CLICK TO NAVIGATE; SECOND CLICK ON SAME CELL TO ACTION
	thisCellId = thisCell.id
	thisCellId == lastCellId? counter = 1 : counter = 0
	lastCellId = thisCellId
	sceneCellId = thisCell.id.split(",")
	genericName = sceneCellId[0]
	commander = genericName
	colNo = sceneCellId[1]
	activeRow = sceneCellId[2]
	entsInd = sceneCellId[3]
	eval("scene"+colNo+"Down")()    
	}




/////FIRST COLUMN


function scene0Down(){
	sliderTops[0] = activeRow
	if(counter == 1) sceneSceneOpen(sceneAspect)
	else{
		params = new Array(colNo,activeRow).join(",")
		sceneSliderAdjust(params)
		document.getElementById("sc"+2).innerHTML =""
		menuList = "Again to confirm"
		sceneDeviceMenuList()
		deviceMenu.style.textAlign = "left"   
		}  
	}





function sceneSceneOpen(sceneAspect){
	params = new Array(activeRow, sceneAspect)
	params = params.join(",")
	window.location = "skp:sceneSceneOpen@"+params  
	}


function sceneSceneSelect(recd){
	sliderTops[0] = recd
	params = new Array(0,recd)
	params = params.join(",")
	sceneSliderAdjust(params)
	eval("scene"+sceneAspect+"List")()  
	}







//SECOND COLUMN



function scene1Down(){
	sliderTops[1] = activeRow
	document.getElementById("sc2").innerHTML = ""
	sceneAspect = genericName
	menuList = eval("scene"+sceneAspect+"Menu")
	sceneDeviceMenuList()
	deviceMenu.style.textAlign = "center"
	params = new Array(colNo,activeRow).join(",")
	sceneSliderAdjust(params)
	eval("scene"+genericName+"List")()   
	}


//THIRD COLUMN

function scene2Down(){
	sliderTops[2]= activeRow
	menuList = ""
	sceneDeviceMenuList()  
	deviceMenu.style.textAlign = "right"
	params = new Array(colNo,activeRow).join(",")
	sceneSliderAdjust(params)
	eval("sceneTools"+genericName)()  
	}
	
	
	

function sceneComponentSelect(ind){
	slider = document.getElementById("sc1")
	list = aspectArray
		for(a=0; a<list.length; a++){
		if(list[a][0] == "Components") activeRow = a 
		}
	cTop = activeRow-stripeTop
	finishTop = -cTop*cellHeight
	slider.style.top = finishTop
	try{
		check = componentsArray
		}
	catch(e){
		sceneComponentsList()
		}
	childNos =componentsArray
		for(a=0; a<childNos.length; a++){
		if(childNos[a][3] == ind) activeRow = a 
		}
	sliderTops[2] = activeRow
	colNo = 2 
	sceneChildrenRun()
	params = new Array(2,activeRow)
	params = params.join(",")
	sceneSliderAdjust(params)
    }






/////SLIDER


function sceneSliderAdjust(params){
	//params may come from observer or function depending on click source
	params = params.split(",")
	colNo = params[0]
	activeRow = params[1]
	slider = document.getElementById("sc"+ colNo)
	startTop = slider.style.top.slice(0,-2)
	cTop = activeRow-stripeTop
	finishTop = -cTop*cellHeight
	diff = startTop-finishTop
	/*
	The following varies the increment and therefore speed depending on distance to be travelled.
	It would be more machine like to ease in and ease out - anyone?
	*/
	if(diff > 0) diff = -diff
	diff = -diff
	lgth = 100
	increment = Math.floor(diff/lgth*10)
	//menuPanel2.innerHTML = diff+" "+lgth+" "+increment - for testing
	sceneSlideStop = setInterval(sceneSlide,5)   
	}




function sceneSlide(){
	theTop = slider.style.top.slice(0,-2)
	if(theTop == finishTop){
		clearInterval(sceneSlideStop)
		// ADJUSTS THE POSITION BECAUSE CURRENT STYLE IS KNOWN
		if(genericName == "Style"){
			params = new Array(2,activeRow).join(",")
			sceneSliderAdjust(params)
			}   
		}
	else{
		eval(startTop)-finishTop > 0? x = -1 :x = 1
		theTop = slider.style.top.slice(0,-2)
		theTop = eval(theTop)+x*increment
		slider.style.top = theTop+"px"    
		}   
	}



//ACTIONS FROM EVENTS IN COLUMNS



function sceneToolsProperty(){
	if(counter==1) scenePropertyToggle()
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()   
		}  
	}


	
	
function sceneToolsLayer(){
	if(counter==1) sceneLayerToggle()
	else{
	//INPUT CELL FROM LAYERS ADD/RENAME
		if(thisCell.tagName =="INPUT") menuList = ""
		else {
			menuList = "Again to toggle"
			sceneDeviceMenuList()   
			}  
		}   
	}




function sceneToolsComponent(){
	if(counter==1) sceneComponentToggle()
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()
		//HIGHLIGHTS BOUNDING BOX
		window.location = "skp:sceneHiliteOn@"+entsInd  
		} 
	}




function sceneToolsView(){
	if(counter==1){
		sceneUpdater()
		word = thisCell.innerHTML
		window.location = "skp:sceneView"+word  
		}
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()   
		}  
	}




function sceneToolsStyle(){
	if(counter==1){
		sceneUpdater()
		window.location = "skp:sceneStyleUse@"+entsInd   
		}
	else{
		menuList = "Again to toggle"
		sceneDeviceMenuList()  
		}   
	}




//MENUS AND ACTIONS

scenePropertiesMenu = "Properties to save"
sceneLayersMenu = "Abc,Visibility,Add"
sceneComponentsMenu = "Pending"

//For Release 2 series

sceneCollectionsMenu = "Will allow selection of collection names"
sceneGroupingsMenu = "Will allow selection of grouping names"

sceneComponentsMenu = "Show_all,Hide_all"
sceneViewsMenu = "Orthogonal views"
sceneStylesMenu = "Styles in model"



function sceneDeviceMenuList(){
	deviceMenu.innerHTML = ""
	list = menuList.split(",")
	for(a=0; a<list.length; a++){
		obj = document.createElement("a")
		deviceMenu.appendChild(obj)
		with(obj){
			innerHTML = list[a]
			className = "menu" 
			}  
		}  
	}




function deviceMenuDown(e){
	coreTarget()
	menuCell = thisCell
	menuName =  menuCell.innerHTML.split(" ").join("")
	menuPanel = deviceMenu
	try{
		eval("scene"+commander+menuName)()
		}
	catch(e){
		}  
	}



function sceneLayersAbc(){
	layerSort = "abc"
	sceneLayersList()
	}


function sceneLayersVisibility(){
	layerSort = "vis"
	sceneLayersList()
	}


function sceneLayersAdd(){
	sliderTops[2] = 0
	window.location = "skp:sceneLayersAdd"
	}



function sceneLayerRename(recd){
	entry = new Array()
	entry[0] = "Layer"
	entry[1] = recd
	entry[2] = "true"
	layersArray.splice(0,0,entry)
	childNos = layersArray
	sliderTops[2] = 0
	colNo = 2
	sceneChildrenRun()  
	newCell = document.getElementById("sc"+2).firstChild
	transferName = newCell.innerHTML
	newCell.innerHTML = ""
	obj = document.createElement("input")
	newCell.appendChild(obj)
	with(obj){
		id = "transferBox"
		value = transferName
		with(style){
			width =cellWidth
			height = cellHeight
			backgroundColor = "pink"   
			}   
		}
	confirmPanel.innerHTML = "CONFIRM" 
	confirmPanel.style.display = "block"
	}



//ONLY FOR NEW NAMES; OTHER RENAMING IN SU LAYER WINDOW



function sceneComponentsShow_all(){
	componentSort = "show"
	//UPDATER
	sceneUpdater()
	params = "Show"
	//CHANGES SU DISPLAY
	window.location = "skp:sceneComponentsToggleAll@"+params
	//Web dialog
	coll = document.getElementById("sc2").childNodes
	for(a=0; a<coll.length; a++){
		coll[a].className = "on"
		}
	list = componentsArray
	for(a = 0; a < list.length; a++){
		list[a][2] = "true"
		}
	}



	

function sceneComponentsHide_all(){
	componentSort = "hide"
	params = "Hide"
	//RETURNS TO DEFAULT
	componentSort = "none" 
	//UPDATER
	sceneUpdater()
	//CHANGES SU DISPLAY
	window.location = "skp:sceneComponentsToggleAll@"+params  
	//Web dialog
	coll = document.getElementById("sc2").childNodes
	for(a=0; a<coll.length; a++){
		coll[a].className = "off"
		}
	list = componentsArray
	for(a = 0; a < list.length; a++){
		list[a][2] = "false"
		}
	}


	

 
function scenePropertyToggle(){
    //CHANGES FONT COLOUR
    thisCell.className == "on"? cl = "off" : cl = "on";
    thisCell.className = cl;
    cl=="on"? sw = "off" : sw = "on";
    //CHANGES SU DISPLAY DIRECTLY - REQUIRES UPDATE TO SAVE
    sceneUpdater();
    //CHANGES SU DISPLAY
    var property = thisCell.innerHTML;
    var callback = "scenePropertyToggle@" + property +"," + sw;
    window.location = "skp:" + callback;
	}




function sceneLayerToggle(){
	thisCell.className == "on"? cl = "off" : cl = "on"
	thisCell.className = cl
	cl=="on"? sw = "off" : sw = "on"
	sceneUpdater()
	fileName = "sceneLayerToggle"+sw
	window.location = "skp:"+fileName+"@"+entsInd   
	}


	
	
function sceneComponentToggle(){
	thisCell.className == "off"? cl = "on" : cl = "off"
	thisCell.className = cl
	cl == "off"? sw = "on" : sw = "off"
	componentsArray[activeRow][2] == "true"? tf = "false" : tf = "true"
	componentsArray[activeRow][2] = tf
	sceneUpdater()
	fileName = "sceneComponentToggle"+sw
	window.location = "skp:"+fileName+"@"+entsInd   
	}

	
	

//SCENE UPDATER

function sceneUpdater(){
	confirmPanel.innerHTML ="UPDATE" 
	confirmPanel.style.display = "block"
	confirmPanel.style.backgroundColor ="#ff0000" 	
	}
	
	
//SCENES ADDED OR REMOVED BY USER

	
function sceneSceneAdd(recd){	
	sceneList = recd
	sceneSceneList()
	}


function sceneSceneRemove(recd){	
	sceneList = recd
	sceneSceneList()
	}
	
	
	
	//SET UP FUNCTIONS



function sceneSet() {
	scenePanelNames() 
    //STANDARD NS ELEMENTS
	sceneSetDeviceHolder()
	sceneSetDeviceMenu()
	sceneStripe()
	//ADD ONS
	sliderTops = new Array(0,0,0)
	sceneColumnSliders()
	//INITIAL LAYOUT
	scenePanelLayout()
	layerSort = "abc"
    componentSort = "none"
    sceneAspect = "Properties"
    commander = "Scenes"  
	}



///// PANEL NAMES



function scenePanelNames()  {
    copyPanel = document.getElementById("copy")
    //namePanel = document.getElementById("name")
    devicePanel = document.getElementById("device")
    confirmPanel = document.getElementById("confirm")
    menuPanel1 = document.getElementById("menu1")
    menuPanel2 = document.getElementById("menu2")   }
	
	
/////DEVICE MENU - fixed panel in devicePanel


function sceneSetDeviceMenu(){
	obj = document.createElement("div")
	devicePanel.appendChild(obj)
	obj.id = "dmenu"
	deviceMenu = document.getElementById("dmenu")
	with(deviceMenu){
		className = "deviceMenu"
		with(style){
			top=0
			width =panelWidth
			height = cellHeight 
			backgroundColor = "yellow"
			}  
		}  
	}

/////DEVICE HOLDER - movable panel in devicePanel



function sceneSetDeviceHolder(){
	obj = document.createElement("div")
	devicePanel.appendChild(obj)
	obj.id = "holder"
	deviceHolder = document.getElementById("holder")
	with(deviceHolder){
		className = "device"
			with(style){
			top = cellHeight
			}  
		}  
	}

	
	





function sceneStripe(){
	obj = document.createElement("div")
	deviceHolder.appendChild(obj)
	obj.id = "stripe"
	stripePanel = document.getElementById("stripe")
	with(stripePanel){
		className = "stripe"
		with(style){
			left = 0
			top = stripeTop * cellHeight
			width = columns * cellWidth
			height = cellHeight  
			} 
		}  
	}


//ADD ON PANELS
	
function sceneColumnSliders(){
	bLeft = 0
	for(a=0; a<columns; a++){
		sceneColumnSlider() 
		bLeft += cellWidth
		}  
	} 


	
	
function sceneColumnSlider(){
	obj = document.createElement("div")
	deviceHolder.appendChild(obj)
	with(obj){
		colNo = a
		id  = "sc"+ colNo 
		
		}  
	}



//ADJUSTS HTML FILE DIVS



function scenePanelLayout(){
	/*with(namePanel){
		with(style){
			left    = 0
			top     = 2 * cellHeight  
			} 
		}*/
	with(devicePanel){
		with(style){
			top = cellHeight*2
			}
		}
	with(confirmPanel){
		with(style){
			left = panelWidth-cellWidth
			top = 0   
			width = cellWidth
			display = "none"
			}
		}
	with(menuPanel1){
		className = "device"
		with(style){
			left = 0
			top = 0 
			width = panelWidth
			height = cellHeight
			}  
		}
	with(menuPanel2){
	className = "device"
		with(style){
			top = cellHeight
			width = panelWidth
			height = cellHeight 
			}  
		} 
	with(copyPanel){
	innerHTML = "&copy;Chris Glasier 2008/9"
	className = "copy"
		with(style){
			width = panelWidth 
			}  
		} 
	//Slider lefts
	bLeft = 0
	for(a=0; a<columns; a++){
		with(document.getElementById("sc"+a).style){
			left = bLeft
			width = cellWidth
			}
		bLeft += cellWidth    
		} 
	with(stripePanel){
		with(style){
			width = panelWidth 
			}  
		}

	with(deviceMenu){
		with(style){
			width = panelWidth 
			}  
		}
	}


	/////RESIZING


function sceneResize(){
    panelWidth = document.body.clientWidth
    panelHeight = document.body.clientHeight
    cellWidth = Math.floor(panelWidth/columns)
    rows = Math.floor(panelHeight/cellHeight)
	scenePanelLayout()  
	}
